/*================================================================================================================*/
// ********************************* THESE ARE THE INFORMATIONS OF THE MAP: ************************************* //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

// RIVER ST JOHN:
// CREATED BY DANY:
// OCTOBER 2007:

/*================================================================================================================*/
// ******************************* MAIN ENTRY POINT FOR RANDOM MAP SCRIPT: ************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*---------------------------------------------------------------------------------------------------------------*/

include "mercenaries.xs";
void main(void)
{

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.01);
/*================================================================================================================*/
// ********************************* CHOOSES WHICH NATIVES APPEAR ON THE MAP: *********************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
   
        int subCiv0=-1;
        int subCiv1=-1;
        int subCiv2=-1;
	    int subCiv3=-1;
	
/*----------------------------------------------------------------------------------------------------------------*/

        int whichVariation = rmRandInt(1,2); 			
 
/*----------------------------------------------------------------------------------------------------------------*/

	    // ALL INCA ALL THE TIME:
        if (rmAllocateSubCivs(4) == true)
   {
		subCiv0=rmGetCivID("Nootka");
        if (subCiv0 >= 0)
        rmSetSubCiv(0, "Nootka");

		subCiv1=rmGetCivID("Nootka");
        if (subCiv1 >= 0)
        rmSetSubCiv(1, "Nootka");

		subCiv2=rmGetCivID("Nootka");
        if (subCiv2 >= 0)
        rmSetSubCiv(2, "Nootka");

		subCiv3=rmGetCivID("Nootka");
        if (subCiv3 >= 0)
        rmSetSubCiv(3, "Nootka");
   }
   
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.05);
/*================================================================================================================*/
// ******************************************** PICKS THE MAP SIZE: ********************************************* //
/*================================================================================================================*/   
// NONE FOR NOW:
/*---------------------------------------------------------------------------------------------------------------*/

	    int playerTiles=25000;
    
		int size=2.0*sqrt(cNumberNonGaiaPlayers*playerTiles);
	    rmEchoInfo("Map size="+size+"m x "+size+"m");
	    rmSetMapSize(632, 632);
	
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.10);
/*================================================================================================================*/
// ***************************************** DEFINE THE MAP PARAMETERS:	***************************************** //	
/*================================================================================================================*/		
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
	
	    // PICKS A DEFAULT WATER HEIGHT:
	    rmSetSeaLevel(1.0);

        // SET MAP ELEVATION PARAMETERS:
		// rmSetMapElevationParameters(long type, float minFrequency, long numberOctaves, float persistence, float heightVariation)
	    rmSetMapElevationParameters(cElevTurbulence, 0.1, 4, 0.3, 2.0);
	    
		// SET SEA TYPE:
		rmSetSeaType("hudson bay");
	    
		// ENABLE LOCAL WATER:
		rmEnableLocalWater(false);		
    
		// SET WIND MAGNITUDE:
		rmSetWindMagnitude(2);

	    // PICKS DEFAULT TERRAIN AND WATER:
		rmSetBaseTerrainMix("saguenay tundra");
	    rmTerrainInitialize("saguenay\ground1_sag",10);
   	
	    // SET MAP TYPE:
		rmSetMapType("saguenay");
	    rmSetMapType("water");
	    rmSetMapType("grass");
    
		// SET LIGHTING:
		rmSetLightingSet("saguenay");
	
	    // MAKE THE CORNERS:
	    rmSetWorldCircleConstraint(true);

	    // CHOOSE MERCS:
	    chooseMercs();

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.15);
/*================================================================================================================*/
// ************************* DEFINE SOME CLASSES: THESE ARE USED LATER FOR CONSTRAINTS: ************************* //   
/*================================================================================================================*/
   
        int classPlayer=rmDefineClass("player");
        rmDefineClass("classHill");
        rmDefineClass("classPatch");
        rmDefineClass("starting settlement");
        rmDefineClass("startingUnit");
        rmDefineClass("classForest");
        rmDefineClass("importantItem");
        rmDefineClass("natives");
	    rmDefineClass("classCliff");
	    rmDefineClass("classMountain");	
        rmDefineClass("classSocket");
        rmDefineClass("classTrees");		
	
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.20);
/*================================================================================================================*/
// ***************************************** DEFINE THE CONSTRAINTS: ******************************************** //
// ************************ THESE ARE USED TO HAVE OBJECTS AND AREAS AVOID EACH OTHER: ************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
   
        // MAP EDGE CONSTRAINTS:
        //int playerEdgeConstraint=rmCreateBoxConstraint("player edge of map", rmXTilesToFraction(6), rmZTilesToFraction(6), 1.0-rmXTilesToFraction(6), 1.0-rmZTilesToFraction(6), 0.01);
	    int playerEdgeConstraint=rmCreatePieConstraint("player edge of map", 0.5, 0.5, rmXFractionToMeters(0.0), rmXFractionToMeters(0.475), rmDegreesToRadians(0), rmDegreesToRadians(360));
	    int coinEdgeConstraint=rmCreateBoxConstraint("coin edge of map", rmXTilesToFraction(7), rmZTilesToFraction(7), 1.0-rmXTilesToFraction(7), 1.0-rmZTilesToFraction(7), 0.01);
	    //int playerEdgeConstraint=rmCreateBoxConstraint("player edge of map", rmXTilesToFraction(25), rmZTilesToFraction(25), 1.0-rmXTilesToFraction(25), 1.0-rmZTilesToFraction(25), 0.01);

        // CARDINAL DIRECTIONS:
	    int Northward=rmCreatePieConstraint("northMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(315), rmDegreesToRadians(135));
	    int Southward=rmCreatePieConstraint("southMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(135), rmDegreesToRadians(315));
	    int Eastward=rmCreatePieConstraint("eastMapConstraint", 0.75, 0.75, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(45), rmDegreesToRadians(225));
	    int Westward=rmCreatePieConstraint("westMapConstraint", 0.5, 0.5, 0, rmZFractionToMeters(0.5), rmDegreesToRadians(225), rmDegreesToRadians(45));

	    int NWconstraint = rmCreateBoxConstraint("stay in NW portion", 0, 0.5, 1, 1);
	    int SEconstraint = rmCreateBoxConstraint("stay in SE portion", 0, 0, 1, 0.5);
	    int NEconstraint = rmCreateBoxConstraint("stay in NE portion", 0.65, 0.0, 1, 1);
	    int SWconstraint = rmCreateBoxConstraint("stay in SW portion", 0, 0.0, 0.5, 1);
	    int extremeNEconstraint = rmCreateBoxConstraint("stay deep into NE portion", 0.6, 0.0, 1.0, 1.0);
   
	    // PLAYER CONSTRAINTS:
	    int playerConstraint=rmCreateClassDistanceConstraint("avoid players", classPlayer, 30.0);
		int playerCloseConstraint=rmCreateClassDistanceConstraint("close avoid players", classPlayer, 15.0);
		
	    int longPlayerConstraint=rmCreateClassDistanceConstraint("stay far away from players", classPlayer, 50.0);
		
		// SEAFOOD AVOIDANCE:
		int fishVsFishID=rmCreateTypeDistanceConstraint("fish v fish", "fish", 18.0);
        int whaleVsWhaleID=rmCreateTypeDistanceConstraint("whale v whale", "beluga", 15.0);
        int fishLand = rmCreateTerrainDistanceConstraint("fish land", "land", true, 6.0);
        int whaleLand = rmCreateTerrainDistanceConstraint("whale v. land", "land", true, 15.0);
 
        // FOREST AVOIDANCE:
	    int forestConstraint=rmCreateClassDistanceConstraint("forest avoids forest", rmClassID("classForest"), 30.0);
		int forestCloseConstraint=rmCreateClassDistanceConstraint("close avoids forest", rmClassID("classForest"), 10.0);
	    
		// DEER HERDS AVOIDANCE:
		int avoidDeer=rmCreateTypeDistanceConstraint("deer avoids deer", "Deer", 15.0);
		int avoidCloseDeer=rmCreateTypeDistanceConstraint("close avoids deer", "Deer", 8.0);
		int avoidMediumDeer=rmCreateTypeDistanceConstraint("medium avoids deer", "Deer", 25.0);
		int avoidVeryFarDeer=rmCreateTypeDistanceConstraint("very far avoids deer", "Deer", 75.0);
		
		// TREES AVOIDANCE:
		int avoidTrees=rmCreateClassDistanceConstraint("stuff avoid Trees", rmClassID("classTrees"), 10.0);
		int avoidCloseTrees=rmCreateClassDistanceConstraint("close avoid Trees", rmClassID("classTrees"), 5.0);
		int avoidVeryCloseTrees=rmCreateClassDistanceConstraint("very close avoid Trees", rmClassID("classTrees"), 2.0);
		int avoidMediumTrees=rmCreateClassDistanceConstraint("medium avoid Trees", rmClassID("classTrees"), 25.0);
		int avoidFarTrees=rmCreateClassDistanceConstraint("far avoid Trees", rmClassID("classTrees"), 50.0);
		int avoidVeryFarTrees=rmCreateClassDistanceConstraint("very far avoid Trees", rmClassID("classTrees"), 75.0);
		
		// NATURE AVOIDANCE:
		int avoidLlama=rmCreateTypeDistanceConstraint("llama avoids llama", "Llama", 60.0);
	    
		// SHEEP AVOIDANCE:
		int avoidSheep=rmCreateTypeDistanceConstraint("avoids sheep", "sheep", 15.0);
		int avoidCloseSheep=rmCreateTypeDistanceConstraint("close avoids sheep", "sheep", 5.0);
		int avoidVeryFarSheep=rmCreateTypeDistanceConstraint("very far avoids sheep", "sheep", 75.0);
	    
		// COIN AVOIDANCE:
		int avoidCoin=rmCreateTypeDistanceConstraint("avoid coin", "gold", 15.0);
		int avoidCloseCoin=rmCreateTypeDistanceConstraint("close avoid coin", "gold", 8.0);
		int avoidMediumCoin=rmCreateTypeDistanceConstraint("medium avoid coin", "gold", 25.0);
		int avoidVeryFarCoin=rmCreateTypeDistanceConstraint("very far avoid coin", "gold", 75.0);
	    
		int avoidCoinFar=rmCreateTypeDistanceConstraint("avoid coin far", "gold", 55.0);
		
		// FRUITS AVOIDANCE:
		int avoidFruits=rmCreateTypeDistanceConstraint("avoid fruits", "berrybush", 15.0);
		int avoidCloseFruits=rmCreateTypeDistanceConstraint("close avoid fruits", "berrybush", 8.0);
		int avoidFarFruits=rmCreateTypeDistanceConstraint("far avoid fruits", "berrybush", 50.0);
   
        // AVOID IMPASSABLE LAND:
	    int avoidImpassableLand=rmCreateTerrainDistanceConstraint("avoid impassable land", "Land", false, 12.0);
		int avoidCloseImpassableLand=rmCreateTerrainDistanceConstraint("close avoid impassable land", "Land", false, 6.0);
	    int avoidMediumImpassableLand=rmCreateTerrainDistanceConstraint("medium avoid impassable land", "Land", false, 6.0);
	    
		
		
		int avoidRiver = rmCreateTerrainDistanceConstraint("avoid river", "Land", false, 5.0);
	    int avoidCliff=rmCreateClassDistanceConstraint("stuff vs. cliff", rmClassID("classCliff"), 12.0);
	    int avoidCliffFar=rmCreateClassDistanceConstraint("stuff vs. cliff far", rmClassID("classCliff"), 22.0);
	    int cliffAvoidCliff=rmCreateClassDistanceConstraint("cliff vs. cliff", rmClassID("classCliff"), 30.0);
	    int mediumShortAvoidImpassableLand=rmCreateTerrainDistanceConstraint("mediumshort avoid impassable land", "Land", false, 8.0);
	    int shortAvoidImpassableLand=rmCreateTerrainDistanceConstraint("short avoid impassable land", "Land", false, 2.0);
	    int mediumAvoidImpassableLand=rmCreateTerrainDistanceConstraint("The medium avoid impassable land", "Land", false, 12.0);

        // UNIT AVOIDANCE:
		int avoidTownCenter=rmCreateTypeDistanceConstraint("avoid Town Center", "townCenter", 20.0);
	    int avoidTownCenterFar=rmCreateTypeDistanceConstraint("avoid Town Center Far", "townCenter", 42.0);
	    int avoidTownCenterSupaFar=rmCreateTypeDistanceConstraint("avoid Town Center Supa Far", "townCenter", 80.0);
	    //int avoidHuari=rmCreateTypeDistanceConstraint("avoid Huari", "HuariStrongholdAndes", 80.0);
	    int avoidCinematicBlock=rmCreateTypeDistanceConstraint("avoid Block", "CinematicBlock", 5.0);
	    int avoidCinematicBlockFar=rmCreateTypeDistanceConstraint("avoid Block Far", "CinematicBlock", 60.0);
	    int avoidImportantItem=rmCreateClassDistanceConstraint("secrets etc avoid each other", rmClassID("importantItem"), 15.0);
	    int shortAvoidImportantItem=rmCreateClassDistanceConstraint("secrets etc avoid each other by a bit", rmClassID("importantItem"), 10.0);
	    
		// NATIVES AVOIDANCE:
		int avoidNatives=rmCreateClassDistanceConstraint("stuff avoids natives", rmClassID("natives"), 15.0);
	    int avoidCloseNatives=rmCreateClassDistanceConstraint("close stuff avoids natives", rmClassID("natives"), 8.0);
	   	int avoidNativesFar=rmCreateClassDistanceConstraint("stuff avoids natives far", rmClassID("natives"), 15.0);
	    
		// NUGGETS AVOIDANCE:
		int avoidNugget=rmCreateTypeDistanceConstraint("nugget avoid nugget", "AbstractNugget", 15.0);
		int avoidCloseNugget=rmCreateTypeDistanceConstraint("close avoid nugget", "AbstractNugget", 8.0);
		int avoidFarNugget=rmCreateTypeDistanceConstraint("far avoid nugget", "AbstractNugget", 50.0);
	    
		
		int avoidNuggetFar=rmCreateTypeDistanceConstraint("nugget avoid nugget far", "AbstractNugget", 45.0);
	    int avoidTradeRouteSockets=rmCreateTypeDistanceConstraint("avoid Trade Socket", "sockettraderoute", 10);
	    int avoidTradeRouteSocketsTC=rmCreateTypeDistanceConstraint("avoid Trade Socket from TC", "sockettraderoute", 60);
	    int avoidIncaSocketsTC=rmCreateTypeDistanceConstraint("avoid Inca Socket from TC", "socketinca", 85);
		
		// SOCKETS AVOIDANCE:
		int avoidSockets=rmCreateTypeDistanceConstraint("avoid sockets", "socket", 15);
		int avoidCloseSockets=rmCreateTypeDistanceConstraint("close avoid sockets", "socket", 5);
	
        // DECORATION AVOIDANCE:
        int avoidAll=rmCreateTypeDistanceConstraint("avoid all", "all", 8.0);
		
		// WATER AVOIDANCE:
		int avoidWater4 = rmCreateTerrainDistanceConstraint("avoid water", "Land", false, 4.0);
        int avoidWater8 = rmCreateTerrainDistanceConstraint("avoid water medium 8", "Land", false, 8.0);
        int avoidWater10 = rmCreateTerrainDistanceConstraint("avoid water medium 10", "Land", false, 10.0);
        int avoidWater12 = rmCreateTerrainDistanceConstraint("avoid water medium 12", "Land", false, 12.0);
        int avoidWater15 = rmCreateTerrainDistanceConstraint("avoid water medium 15", "Land", false, 15.0);
        int avoidWater20 = rmCreateTerrainDistanceConstraint("avoid water long", "Land", false, 20.0);

        // TRADE ROUTE AVOIDANCE:
        int avoidTradeRoute = rmCreateTradeRouteDistanceConstraint("trade route", 15.0);
		int avoidCloseTradeRoute = rmCreateTradeRouteDistanceConstraint("close trade route", 5.0);
		
        int avoidTradeRouteForest = rmCreateTradeRouteDistanceConstraint("trade route forest", 8.0);
        int avoidTradeRouteFar = rmCreateTradeRouteDistanceConstraint("trade route far", 50.0);
        int avoidTradeRouteTC = rmCreateTradeRouteDistanceConstraint("TC avoid trade route", 20.0);
   
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.25);
/*================================================================================================================*/
// DEFINE OBJECTS:
// THESE OBJECTS ARE ALL DEFINED SO THEY CAN BE PLACED LATER:
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.30);
/*================================================================================================================*/
// ************************************** SET UP PLAYER STARTING LOCATIONS: ************************************* //		
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

       if ( whichVariation == 1 )
   {
		rmSetPlacementTeam(0);
		rmPlacePlayersLine(0.625, 0.875, 0.875, 0.625, 0.0, 0.0);
		rmSetPlacementTeam(1);
	   	//rmPlacePlayersLine(0.125, 0.375, 0.375, 0.125, 0.0, 0.0);
		rmPlacePlayersLine(0.375, 0.125, 0.125, 0.375, 0.0, 0.0);
   }
        else
   {
		rmSetPlacementTeam(0);
		rmPlacePlayersLine(0.125, 0.375, 0.375, 0.125, 0.0, 0.0);
		rmSetPlacementTeam(1);
		//rmPlacePlayersLine(0.625, 0.875, 0.875, 0.625, 0.0, 0.0);
		rmPlacePlayersLine(0.875, 0.625, 0.625, 0.875, 0.0, 0.0);
   } 

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.35);
/*================================================================================================================*/
// ************************************** DEFINE AND BUILD A NORTH AREA: **************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

        int northIslandID = rmCreateArea("north island");
	    rmSetAreaLocation(northIslandID, 0.80, 0.80); 
	    rmSetAreaWarnFailure(northIslandID, false);
	    rmSetAreaSize(northIslandID, 0.335, 0.335);
	    //rmSetAreaCoherence(northIslandID, 0.5);
		rmSetAreaCoherence(northIslandID, 1.0);

	    rmSetAreaElevationType(northIslandID, cElevTurbulence);
	    rmSetAreaElevationVariation(northIslandID, 3.0);
	    rmSetAreaBaseHeight(northIslandID, 4.0);
	    rmSetAreaElevationMinFrequency(northIslandID, 0.07);
	    rmSetAreaElevationOctaves(northIslandID, 4);
	    rmSetAreaElevationPersistence(northIslandID, 0.5);
	    rmSetAreaElevationNoiseBias(northIslandID, 1);
   
	    rmSetAreaObeyWorldCircleConstraint(northIslandID, false);
	    rmSetAreaMix(northIslandID, "saguenay tundra");
	    //rmSetAreaMix(northIslandID, "texas_dirt");
		
		rmBuildAllAreas();
		
		int northIslandConstraint=rmCreateAreaConstraint("north Island", northIslandID);

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.40);
/*================================================================================================================*/
// *************************************** DEFINE AND BUILD A SOUTH AREA: *************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

        int southIslandID = rmCreateArea("south island");
        rmSetAreaLocation(southIslandID, 0.20, 0.20); 
        rmSetAreaWarnFailure(southIslandID, false);
        rmSetAreaSize(southIslandID, 0.335, 0.335);
        //rmSetAreaCoherence(southIslandID, 0.5);
        rmSetAreaCoherence(southIslandID, 1.0);

	    rmSetAreaElevationType(southIslandID, cElevTurbulence);
        rmSetAreaElevationVariation(southIslandID, 5.0);
        rmSetAreaBaseHeight(southIslandID, 3.0);
        rmSetAreaElevationMinFrequency(southIslandID, 0.07);
        rmSetAreaElevationOctaves(southIslandID, 4);
        rmSetAreaElevationPersistence(southIslandID, 0.5);
	    rmSetAreaElevationNoiseBias(southIslandID, 1); 
//        rmAddAreaTerrainLayer(southIslandID, "andes\ground10_and", 0, 5);
        //rmAddAreaTerrainLayer(southIslandID, "andes\ground07_and", 3, 8);
        //rmAddAreaTerrainLayer(southIslandID, "andes\ground4_and", 6, 8);
   
	    rmSetAreaObeyWorldCircleConstraint(southIslandID, false);
	    rmSetAreaMix(southIslandID, "saguenay tundra");
	    //rmSetAreaMix(southIslandID, "texas_dirt");
		
		int southIslandConstraint=rmCreateAreaConstraint("south Island", southIslandID);

        rmBuildAllAreas(); 
		
/*================================================================================================================*/		
// *************************************** DEFINE AND BUILD A WEST AREA: **************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

        int westIslandID = rmCreateArea("west island");
        rmSetAreaLocation(westIslandID, 0.20, 0.80); 
        rmSetAreaWarnFailure(westIslandID, false);
        rmSetAreaSize(westIslandID, 0.080, 0.080);
        //rmSetAreaCoherence(westIslandID, 0.5);
        rmSetAreaCoherence(westIslandID, 1.0);

	    rmSetAreaElevationType(westIslandID, cElevTurbulence);
        rmSetAreaElevationVariation(westIslandID, 5.0);
        rmSetAreaBaseHeight(westIslandID, 3.0);
        rmSetAreaElevationMinFrequency(westIslandID, 0.07);
        rmSetAreaElevationOctaves(westIslandID, 4);
        rmSetAreaElevationPersistence(westIslandID, 0.5);
	    rmSetAreaElevationNoiseBias(westIslandID, 1); 
//        rmAddAreaTerrainLayer(westIslandID, "andes\ground10_and", 0, 5);
        //rmAddAreaTerrainLayer(westIslandID, "andes\ground07_and", 3, 8);
        //rmAddAreaTerrainLayer(westIslandID, "andes\ground4_and", 6, 8);
   
	    rmSetAreaObeyWorldCircleConstraint(westIslandID, false);
	    rmSetAreaMix(westIslandID, "saguenay tundra");
	    //rmSetAreaMix(westIslandID, "rockies_snow");
		//rmSetAreaMix(westIslandID, "rockies_grass");

        rmBuildAllAreas();

        int westIslandConstraint=rmCreateAreaConstraint("west Island", westIslandID);

/*================================================================================================================*/		
// **************************************** DEFINE AND BUILD A EAST AREA: *************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

        int eastIslandID = rmCreateArea("east island");
        rmSetAreaLocation(eastIslandID, 0.80, 0.20); 
        rmSetAreaWarnFailure(eastIslandID, false);
        rmSetAreaSize(eastIslandID, 0.080, 0.080);
        //rmSetAreaCoherence(eastIslandID, 0.5);
        rmSetAreaCoherence(eastIslandID, 1.0);

	    rmSetAreaElevationType(eastIslandID, cElevTurbulence);
        rmSetAreaElevationVariation(eastIslandID, 5.0);
        rmSetAreaBaseHeight(eastIslandID, 3.0);
        rmSetAreaElevationMinFrequency(eastIslandID, 0.07);
        rmSetAreaElevationOctaves(eastIslandID, 4);
        rmSetAreaElevationPersistence(eastIslandID, 0.5);
	    rmSetAreaElevationNoiseBias(eastIslandID, 1); 
//        rmAddAreaTerrainLayer(eastIslandID, "andes\ground10_and", 0, 5);
        //rmAddAreaTerrainLayer(eastIslandID, "andes\ground07_and", 3, 8);
        //rmAddAreaTerrainLayer(eastIslandID, "andes\ground4_and", 6, 8);
   
	    rmSetAreaObeyWorldCircleConstraint(eastIslandID, false);
	    rmSetAreaMix(eastIslandID, "saguenay tundra");
	    //rmSetAreaMix(eastIslandID, "rockies_snow");
		//rmSetAreaMix(eastIslandID, "rockies_grass");

        rmBuildAllAreas();

        int eastIslandConstraint=rmCreateAreaConstraint("east Island", eastIslandID);

/*================================================================================================================*/
// ************************************ DEFINE AND PLACE THE SAGUENAY RIVER: ************************************ //
/*================================================================================================================*/

	    int saguenayRiver = rmRiverCreate(-1, "saguenay lake", 5, 5, 18, 18);
	
        rmRiverSetConnections(saguenayRiver, 0.0, 0.0, 1.0, 1.0);
   
        rmRiverSetShallowRadius(saguenayRiver, 10);
        rmRiverAddShallow(saguenayRiver, rmRandFloat(0.35, 0.35));
        rmRiverAddShallow(saguenayRiver, rmRandFloat(0.65, 0.65));
   
        rmRiverSetBankNoiseParams(saguenayRiver, 0.07, 2, 1.5, 20.0, 0.667, 2.0);
  
        rmRiverBuild(saguenayRiver);
        //rmRiverReveal(saguenayRiver, 2); 

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.45);
/*================================================================================================================*/   
// **************************************** SET UP THE PLAYER AREAS: ******************************************** //	
/*================================================================================================================*/

        float playerFraction=rmAreaTilesToFraction(1750);
    
		for(i=1; <cNumberPlayers)
   {
        // CREATE THE AREA:
        int id=rmCreateArea("Player"+i);
    
		// ASSIGN TO THE PLAYER:
        rmSetPlayerArea(i, id);
    
		// SET THE SIZE:
        rmSetAreaSize(id, playerFraction, playerFraction);
    
		// ADD AREA TO CLASS:
		rmAddAreaToClass(id, classPlayer);
    
		// SET AREA MIN AND MAX:
		rmSetAreaMinBlobs(id, 1);
        rmSetAreaMaxBlobs(id, 1);
    
		// ADD AREA CONSTRAINT:
		rmAddAreaConstraint(id, playerConstraint); 
        rmAddAreaConstraint(id, playerEdgeConstraint);
    
		// SET AREA LOC PLAYER:
		rmSetAreaLocPlayer(id, i);
    
		// SET AREA TERRAIN TYPE:
		//rmSetAreaTerrainType(id, "carolina\marshflats");
	
		// SET AREA COHERENCE:
		rmSetAreaCoherence(id, 1.0);
	
		// SET AREA MIX:
		//rmSetAreaMix(id, "rockies_snow");
	
		// SET AREA TERRAIN TYPE:
		//rmSetAreaTerrainType(id, "rockies\groundsnow1_roc");
	
		// SET AREA TERRAIN TYPE:
		//rmSetAreaTerrainType(id, "texas\ground2");
    
		// SET AREA BASE HEIGHT:
		//rmSetAreaBaseHeight(id, 18.0);
    
		// SET AREA WARN FAILURE:
		rmSetAreaWarnFailure(id, false);
   }
        // BUILD THE AREAS:
        rmBuildAllAreas();

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.45);
/*================================================================================================================*/
// ***************************** DEFINE AND PLACE THE TRADE ROUTE AND THE SOCKETS: ****************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

        // CLEAR OUT CONSTRAINS FOR GOOD MEASURE:
        rmClearClosestPointConstraints();
   
/*----------------------------------------------------------------------------------------------------------------*/   

	    // SOCKET DEFINITION:
	    int socketID=rmCreateObjectDef("sockets to dock Trade Posts");
	    rmAddObjectDefItem(socketID, "SocketTradeRoute", 1, 0.0);
	    rmSetObjectDefAllowOverlap(socketID, true);
		rmAddObjectDefToClass(socketID, rmClassID("classSocket"));
	    rmSetObjectDefMinDistance(socketID, 0.0);
	    rmSetObjectDefMaxDistance(socketID, 8.0);
		
/*----------------------------------------------------------------------------------------------------------------*/		

	    // TRADE ROUTE 1:
		int tradeRoute1ID = rmCreateTradeRoute();
	    rmAddTradeRouteWaypoint(tradeRoute1ID, 0.63, 0.050);
		rmAddTradeRouteWaypoint(tradeRoute1ID, 0.63, 0.375);
		rmAddTradeRouteWaypoint(tradeRoute1ID, 0.95, 0.375);
	
	    bool placedTradeRoute1 = rmBuildTradeRoute(tradeRoute1ID, "dirt");
	    if(placedTradeRoute1 == false)
		rmEchoError("Failed to place trade route one");

	    // ADD THE MEETING SOCKETS ALONG THE TRADE ROUTE:
	    rmSetObjectDefTradeRouteID(socketID, tradeRoute1ID);
	    vector socketLoc1 = rmGetTradeRouteWayPoint(tradeRoute1ID, 0.05);
	    rmPlaceObjectDefAtPoint(socketID, 0, socketLoc1);

	    socketLoc1 = rmGetTradeRouteWayPoint(tradeRoute1ID, 0.50);
	    rmPlaceObjectDefAtPoint(socketID, 0, socketLoc1);
		
		socketLoc1 = rmGetTradeRouteWayPoint(tradeRoute1ID, 0.95);
	    rmPlaceObjectDefAtPoint(socketID, 0, socketLoc1);
		
/*----------------------------------------------------------------------------------------------------------------*/		

	    // TRADE ROUTE 2:
		int tradeRoute2ID = rmCreateTradeRoute();
	    rmAddTradeRouteWaypoint(tradeRoute2ID, 0.050, 0.63);
		rmAddTradeRouteWaypoint(tradeRoute2ID, 0.375, 0.63);
		rmAddTradeRouteWaypoint(tradeRoute2ID, 0.375, 0.95);

	    bool placedTradeRoute2 = rmBuildTradeRoute(tradeRoute2ID, "dirt");
	    if(placedTradeRoute2 == false)
		rmEchoError("Failed to place trade route 2");

	    // ADD THE MEETING SOCKETS ALONG THE TRADE ROUTE:
	    rmSetObjectDefTradeRouteID(socketID, tradeRoute2ID);
	    vector socketLoc2 = rmGetTradeRouteWayPoint(tradeRoute2ID, 0.05);
	    rmPlaceObjectDefAtPoint(socketID, 0, socketLoc2);
	
    	socketLoc2 = rmGetTradeRouteWayPoint(tradeRoute2ID, 0.50);
	    rmPlaceObjectDefAtPoint(socketID, 0, socketLoc2);

	    socketLoc2 = rmGetTradeRouteWayPoint(tradeRoute2ID, 0.95);
	    rmPlaceObjectDefAtPoint(socketID, 0, socketLoc2);

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.50);
/*================================================================================================================*/
// ************************************ DEFINE AND PLACE THE NATIVE TRIBES: ************************************* //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

	    if (subCiv0 == rmGetCivID("Nootka"))
	{  
		int nootkaVillageAID = -1;
		nootkaVillageAID = rmCreateGrouping("nootka village 1", "native nootka village "+1);
		rmSetGroupingMinDistance(nootkaVillageAID, 0.0);
		rmSetGroupingMaxDistance(nootkaVillageAID, 0.0);
		rmAddGroupingToClass(nootkaVillageAID, rmClassID("natives"));
		//rmAddGroupingToClass(nootkaVillageAID, rmClassID("importantItem"));
		//rmAddGroupingConstraint(nootkaVillageAID, avoidTradeRoute);
		//rmAddGroupingConstraint(nootkaVillageAID, avoidNatives);
		rmPlaceGroupingAtLoc(nootkaVillageAID, 0, 0.15, 0.75);
	}
	
/*----------------------------------------------------------------------------------------------------------------*/

	    if (subCiv1 == rmGetCivID("Nootka"))
	{  
		int nootkavillageBID = -1;
		nootkavillageBID = rmCreateGrouping("nootka village 2", "native nootka village "+2);
		rmSetGroupingMinDistance(nootkavillageBID, 0.0);
		rmSetGroupingMaxDistance(nootkavillageBID, 0.0);
		rmAddGroupingToClass(nootkavillageBID, rmClassID("natives"));
		//rmAddGroupingToClass(nootkavillageBID, rmClassID("importantItem"));
		//rmAddGroupingConstraint(nootkavillageBID, avoidTradeRoute);
		//rmAddGroupingConstraint(nootkavillageBID, avoidNatives);
		rmPlaceGroupingAtLoc(nootkavillageBID, 0, 0.25, 0.85);
	}
	
/*----------------------------------------------------------------------------------------------------------------*/

	    if (subCiv2 == rmGetCivID("Nootka"))
	{  
		int nootkavillageCID = -1;
		nootkavillageCID = rmCreateGrouping("nootka village 3", "native nootka village "+3);
		rmSetGroupingMinDistance(nootkavillageCID, 0.0);
		rmSetGroupingMaxDistance(nootkavillageCID, 0.0);
		rmAddGroupingToClass(nootkavillageCID, rmClassID("natives"));
		//rmAddGroupingToClass(nootkavillageCID, rmClassID("importantItem"));
		//rmAddGroupingConstraint(nootkavillageCID, avoidTradeRoute);
		//rmAddGroupingConstraint(nootkavillageCID, avoidNatives);
		rmPlaceGroupingAtLoc(nootkavillageCID, 0, 0.85, 0.25);
		
	}
	
/*----------------------------------------------------------------------------------------------------------------*/

	    if (subCiv3 == rmGetCivID("Nootka"))
	{  
		int nootkavillageDID = -1;
		nootkavillageDID = rmCreateGrouping("nootka village 4", "native nootka village "+4);
		rmSetGroupingMinDistance(nootkavillageDID, 0.0);
		rmSetGroupingMaxDistance(nootkavillageDID, 0.0);
		rmAddGroupingToClass(nootkavillageDID, rmClassID("natives"));
		//rmAddGroupingToClass(nootkavillageDID, rmClassID("importantItem"));
		//rmAddGroupingConstraint(nootkavillageDID, avoidTradeRoute);
		//rmAddGroupingConstraint(nootkavillageDID, avoidNatives);
		rmPlaceGroupingAtLoc(nootkavillageDID, 0, 0.75, 0.15);
	}

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.55);
/*================================================================================================================*/
// ******************************************* VARIABLES NEEDED LATER: ****************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

	    int failCount = -1;

	    int numTries=cNumberNonGaiaPlayers+2;
	
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.60);
/*================================================================================================================*/
// ****************** DEFINE THE STARTING TCID AND THE STARTING UNITS AND THE PLAYER RESOURCES: ***************** //	
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

        
	    // PLAYER STARTING RESOURCES
	    rmClearClosestPointConstraints();

	    int TCID = rmCreateObjectDef("player TC");
	    if (rmGetNomadStart())
	{
		rmAddObjectDefItem(TCID, "CoveredWagon", 1, 0.0);
	}
	    else
	{
		rmAddObjectDefItem(TCID, "TownCenter", 1, 0.0);
	}

	    rmAddObjectDefConstraint(TCID, playerEdgeConstraint);
	    
		rmAddObjectDefConstraint(TCID, avoidTradeRouteTC);
		rmAddObjectDefConstraint(TCID, avoidTradeRouteSocketsTC);
		//rmAddObjectDefConstraint(TCID, avoidCinematicBlockFar);

	    rmSetObjectDefMinDistance(TCID, 0.0);
	    rmSetObjectDefMaxDistance(TCID, 0.0);

	    rmAddObjectDefConstraint(TCID, avoidIncaSocketsTC);
	    rmAddObjectDefConstraint(TCID, avoidTownCenterFar);
	    rmAddObjectDefConstraint(TCID, mediumShortAvoidImpassableLand);
		
/*----------------------------------------------------------------------------------------------------------------*/		
		
		// DEFINE THE STARTING UNITS:
		int startingUnits = rmCreateStartingUnitsObjectDef(5.0);
        rmSetObjectDefMinDistance(startingUnits, 5.0);
        rmSetObjectDefMaxDistance(startingUnits, 10.0);
	    rmAddObjectDefConstraint(startingUnits, avoidAll);
		
/*----------------------------------------------------------------------------------------------------------------*/		

		// DEFINE THE PLAYER SILVER:
		int playerSilverID = rmCreateObjectDef("player mine");
	    
		if ( whichVariation == 1 )
	{	
		rmAddObjectDefItem(playerSilverID, "mine", 1, 0);
	}
        else
    {
        rmAddObjectDefItem(playerSilverID, "minegold", 1, 0);
    }		
		rmAddObjectDefConstraint(playerSilverID, avoidTradeRoute);
	    rmAddObjectDefConstraint(playerSilverID, avoidTownCenter);
	    rmSetObjectDefMinDistance(playerSilverID, 18.0);
	    rmSetObjectDefMaxDistance(playerSilverID, 24.0);
        rmAddObjectDefConstraint(playerSilverID, avoidCoin);

	    // DEFINE THE PLAYER BERRYBUSH:
		int playerberryID=rmCreateObjectDef("player berry");
        rmAddObjectDefItem(playerberryID, "berrybush", rmRandInt(3,5), 6.0);
        rmSetObjectDefMinDistance(playerberryID, 16);
        rmSetObjectDefMaxDistance(playerberryID, 22);
	    rmAddObjectDefConstraint(playerberryID, avoidAll);
        rmAddObjectDefConstraint(playerberryID, avoidImpassableLand);
	    rmAddObjectDefConstraint(playerberryID, avoidFruits);
        rmSetObjectDefCreateHerd(playerberryID, true);

	    // DEFINE THE PLAYER NUGGET:
		int playerNuggetID= rmCreateObjectDef("player nugget"); 
	    rmAddObjectDefItem(playerNuggetID, "Nugget", 1, 0.0);
	    rmSetNuggetDifficulty(1, 1);
	    rmAddObjectDefConstraint(playerNuggetID, avoidFruits);
  	    rmAddObjectDefConstraint(playerNuggetID, avoidNugget);
  	    rmAddObjectDefConstraint(playerNuggetID, avoidTradeRoute);
  	    rmAddObjectDefConstraint(playerNuggetID, avoidAll);
	    rmAddObjectDefConstraint(playerNuggetID, avoidTrees);
	    rmAddObjectDefConstraint(playerNuggetID, playerEdgeConstraint);
	    rmSetObjectDefMinDistance(playerNuggetID, 20.0);
	    rmSetObjectDefMaxDistance(playerNuggetID, 30.0);

	    // DEFINE THE PLAYER TREE:
		int playerTreeID=rmCreateObjectDef("player trees");
        rmAddObjectDefItem(playerTreeID, "TreeSaguenay", rmRandInt(7,12), 8.0);
        rmSetObjectDefMinDistance(playerTreeID, 15);
        rmSetObjectDefMaxDistance(playerTreeID, 30);
	    rmAddObjectDefConstraint(playerTreeID, avoidAll);
        rmAddObjectDefConstraint(playerTreeID, avoidTrees); 

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.65);
/*================================================================================================================*/
// ****************** PLACE THE STARTING TCID AND THE STARTING UNITS AND THE PLAYER RESOURCES: ****************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

	    for(i=1; <cNumberPlayers)
	{
		rmPlaceObjectDefAtLoc(TCID, i, rmPlayerLocXFraction(i), rmPlayerLocZFraction(i));
		vector TCLoc = rmGetUnitPosition(rmGetUnitPlacedOfPlayer(TCID, i));
		rmPlaceObjectDefAtLoc(startingUnits, i, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
		rmPlaceObjectDefAtLoc(playerSilverID, 0, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
		rmPlaceObjectDefAtLoc(playerSilverID, 0, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
		rmPlaceObjectDefAtLoc(playerTreeID, 0, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
		rmPlaceObjectDefAtLoc(playerTreeID, 0, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
		rmPlaceObjectDefAtLoc(playerTreeID, 0, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
		rmPlaceObjectDefAtLoc(playerberryID, 0, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
		rmPlaceObjectDefAtLoc(playerberryID, 0, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
		rmPlaceObjectDefAtLoc(playerNuggetID, 0, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));
        rmPlaceObjectDefAtLoc(playerNuggetID, 0, rmXMetersToFraction(xsVectorGetX(TCLoc)), rmZMetersToFraction(xsVectorGetZ(TCLoc)));

		rmClearClosestPointConstraints();
	}
/*================================================================================================================*/	
// ************************************* DEFINE AND PLACE THE CLIFF AREAS: ************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.70);
/*================================================================================================================*/
// *************************************** DEFINE AND PLACE THE NUGGETS: **************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
 
	    // THE NORTHERN NUGGETS:
		int nuggetID= rmCreateObjectDef("The Nugget 1"); 
	    rmAddObjectDefItem(nuggetID, "Nugget", 1, 0.0);
	    rmSetObjectDefMinDistance(nuggetID, 0.0);
	    rmSetObjectDefMaxDistance(nuggetID, rmXFractionToMeters(0.5));
	    
		rmAddObjectDefConstraint(nuggetID, avoidCloseImpassableLand);
  	    rmAddObjectDefConstraint(nuggetID, avoidFarNugget);
  	    rmAddObjectDefConstraint(nuggetID, northIslandConstraint);
		rmAddObjectDefConstraint(nuggetID, playerEdgeConstraint);
  	    rmAddObjectDefConstraint(nuggetID, avoidAll);
		rmAddObjectDefConstraint(nuggetID, forestConstraint);
  	    rmAddObjectDefConstraint(nuggetID, avoidWater15);
	    rmAddObjectDefConstraint(nuggetID, playerCloseConstraint);
	    
		rmSetNuggetDifficulty(1, 2);
		rmSetNuggetDifficulty(1, 2);
		if (cNumberNonGaiaPlayers<=2)
		rmPlaceObjectDefAtLoc(nuggetID, 0, 0.5, 0.5, 3*cNumberNonGaiaPlayers);
		else
		rmPlaceObjectDefAtLoc(nuggetID, 0, 0.5, 0.5, 1.5*cNumberNonGaiaPlayers);	
	    		
/*----------------------------------------------------------------------------------------------------------------*/

        // THE SOUTHERN NUGGETS:
		int nugget2ID= rmCreateObjectDef("The Nugget 2"); 
	    rmAddObjectDefItem(nugget2ID, "Nugget", 1, 0.0);
	    rmSetObjectDefMinDistance(nugget2ID, 0.0);
	    rmSetObjectDefMaxDistance(nugget2ID, rmXFractionToMeters(0.5));
	    
		rmAddObjectDefConstraint(nugget2ID, avoidCloseImpassableLand);
  	    rmAddObjectDefConstraint(nugget2ID, avoidFarNugget);
  	    rmAddObjectDefConstraint(nugget2ID, southIslandConstraint);
  	    rmAddObjectDefConstraint(nugget2ID, avoidAll);
		rmAddObjectDefConstraint(nugget2ID, playerEdgeConstraint);
  	    rmAddObjectDefConstraint(nugget2ID, avoidWater15);
	    rmAddObjectDefConstraint(nugget2ID, playerCloseConstraint);
	    
		rmSetNuggetDifficulty(1, 2);
		if (cNumberNonGaiaPlayers<=2)
		rmPlaceObjectDefAtLoc(nugget2ID, 0, 0.5, 0.5, 3*cNumberNonGaiaPlayers);
		else
		rmPlaceObjectDefAtLoc(nugget2ID, 0, 0.5, 0.5, 1.5*cNumberNonGaiaPlayers);	
	
/*----------------------------------------------------------------------------------------------------------------*/

        // THE WESTERN NUGGETS:
		int nugget3ID= rmCreateObjectDef("The Nugget 3"); 
	    rmAddObjectDefItem(nugget3ID, "Nugget", 1, 0.0);
	    rmSetObjectDefMinDistance(nugget3ID, 0.0);
	    rmSetObjectDefMaxDistance(nugget3ID, rmXFractionToMeters(0.5));
	    
		rmAddObjectDefConstraint(nugget3ID, avoidCloseImpassableLand);
  	    rmAddObjectDefConstraint(nugget3ID, avoidFarNugget);
  	    rmAddObjectDefConstraint(nugget3ID, westIslandConstraint);
  	    rmAddObjectDefConstraint(nugget3ID, avoidAll);
		rmAddObjectDefConstraint(nugget3ID, avoidCloseNatives);
		rmAddObjectDefConstraint(nugget3ID, playerEdgeConstraint);
  	    rmAddObjectDefConstraint(nugget3ID, avoidTradeRoute);
	    rmAddObjectDefConstraint(nugget3ID, avoidSockets);
	    
		rmSetNuggetDifficulty(1, 2);
		if (cNumberNonGaiaPlayers<=2)
		rmPlaceObjectDefAtLoc(nugget3ID, 0, 0.5, 0.5, 1.0*cNumberNonGaiaPlayers);
		else
		rmPlaceObjectDefAtLoc(nugget3ID, 0, 0.5, 0.5, 0.50*cNumberNonGaiaPlayers);	
		
/*----------------------------------------------------------------------------------------------------------------*/

        // THE EASTERN NUGGETS:
		int nugget4ID= rmCreateObjectDef("The Nugget 4"); 
	    rmAddObjectDefItem(nugget4ID, "Nugget", 1, 0.0);
	    rmSetObjectDefMinDistance(nugget4ID, 0.0);
	    rmSetObjectDefMaxDistance(nugget4ID, rmXFractionToMeters(0.5));
	    
		rmAddObjectDefConstraint(nugget4ID, avoidCloseImpassableLand);
  	    rmAddObjectDefConstraint(nugget4ID, avoidFarNugget);
  	    rmAddObjectDefConstraint(nugget4ID, eastIslandConstraint);
  	    rmAddObjectDefConstraint(nugget4ID, avoidAll);
		rmAddObjectDefConstraint(nugget4ID, avoidCloseNatives);
		rmAddObjectDefConstraint(nugget4ID, playerEdgeConstraint);
  	    rmAddObjectDefConstraint(nugget4ID, avoidTradeRoute);
	    rmAddObjectDefConstraint(nugget4ID, avoidSockets);
	    
		rmSetNuggetDifficulty(1, 2);
		if (cNumberNonGaiaPlayers<=2)
		rmPlaceObjectDefAtLoc(nugget4ID, 0, 0.5, 0.5, 1.0*cNumberNonGaiaPlayers);
		else
		rmPlaceObjectDefAtLoc(nugget4ID, 0, 0.5, 0.5, 0.50*cNumberNonGaiaPlayers);			

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.75);
/*================================================================================================================*/

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.80);
/*================================================================================================================*/
// ************************************* DEFINE AND PLACE THE SILVER MINES: ************************************* //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

        // THE NORTHERN SILVER MINES:
		int silverID = rmCreateObjectDef("silver north");
		
		if ( whichVariation == 1 )
	{	
		rmAddObjectDefItem(silverID, "mine", 1, 0);
	}
        else
    {
        rmAddObjectDefItem(silverID, "minegold", 1, 0);
    }	
	    
        rmSetObjectDefMinDistance(silverID, 0.0);
        rmSetObjectDefMaxDistance(silverID, rmXFractionToMeters(0.5));
	    rmAddObjectDefConstraint(silverID, avoidVeryFarCoin);
        rmAddObjectDefConstraint(silverID, avoidAll);
		rmAddObjectDefConstraint(silverID, avoidWater12);
        rmAddObjectDefConstraint(silverID, avoidSockets);
	    rmAddObjectDefConstraint(silverID, avoidTradeRoute);
	    rmAddObjectDefConstraint(silverID, avoidNatives);
        rmAddObjectDefConstraint(silverID, avoidMediumImpassableLand);
	    rmAddObjectDefConstraint(silverID, playerCloseConstraint);
	    rmAddObjectDefConstraint(silverID, playerEdgeConstraint);
	    rmAddObjectDefConstraint(silverID, northIslandConstraint);
		
		if (cNumberNonGaiaPlayers<=2)
		rmPlaceObjectDefAtLoc(silverID, 0, 0.5, 0.5, 2*cNumberNonGaiaPlayers);
		else
		rmPlaceObjectDefAtLoc(silverID, 0, 0.5, 0.5, 1*cNumberNonGaiaPlayers);	
		
/*----------------------------------------------------------------------------------------------------------------*/

        // THE SOUTHERN SILVER MINES:
		int silver2ID = rmCreateObjectDef("silver south");
		
		if ( whichVariation == 1 )
	{	
		rmAddObjectDefItem(silver2ID, "mine", 1, 0);
	}
        else
    {
        rmAddObjectDefItem(silver2ID, "minegold", 1, 0);
    }	
	    
        rmSetObjectDefMinDistance(silver2ID, 0.0);
        rmSetObjectDefMaxDistance(silver2ID, rmXFractionToMeters(0.5));
	    rmAddObjectDefConstraint(silver2ID, avoidVeryFarCoin);
        rmAddObjectDefConstraint(silver2ID, avoidAll);
		rmAddObjectDefConstraint(silver2ID, avoidWater12);
        rmAddObjectDefConstraint(silver2ID, avoidSockets);
	    rmAddObjectDefConstraint(silver2ID, avoidTradeRoute);
	    rmAddObjectDefConstraint(silver2ID, avoidNatives);
        rmAddObjectDefConstraint(silver2ID, avoidMediumImpassableLand);
	    rmAddObjectDefConstraint(silver2ID, playerCloseConstraint);
	    rmAddObjectDefConstraint(silver2ID, playerEdgeConstraint);
	    rmAddObjectDefConstraint(silver2ID, southIslandConstraint);
		
		if (cNumberNonGaiaPlayers<=2)
		rmPlaceObjectDefAtLoc(silver2ID, 0, 0.5, 0.5, 2*cNumberNonGaiaPlayers);
		else
		rmPlaceObjectDefAtLoc(silver2ID, 0, 0.5, 0.5, 1*cNumberNonGaiaPlayers);
		
/*----------------------------------------------------------------------------------------------------------------*/		

        // THE WESTERN SILVER MINES:
		int silver3ID = rmCreateObjectDef("silver west");
		
		if ( whichVariation == 1 )
	{	
		rmAddObjectDefItem(silver3ID, "mine", 1, 0);
	}
        else
    {
        rmAddObjectDefItem(silver3ID, "minegold", 1, 0);
    }	
	    
        rmSetObjectDefMinDistance(silver3ID, 0.0);
        rmSetObjectDefMaxDistance(silver3ID, rmXFractionToMeters(0.5));
	    rmAddObjectDefConstraint(silver3ID, avoidVeryFarCoin);
        rmAddObjectDefConstraint(silver3ID, avoidAll);
		//rmAddObjectDefConstraint(silver3ID, avoidWater12);
        rmAddObjectDefConstraint(silver3ID, avoidSockets);
	    rmAddObjectDefConstraint(silver3ID, avoidTradeRoute);
	    rmAddObjectDefConstraint(silver3ID, avoidNatives);
        rmAddObjectDefConstraint(silver3ID, avoidMediumImpassableLand);
	    //rmAddObjectDefConstraint(silver3ID, playerCloseConstraint);
	    rmAddObjectDefConstraint(silver3ID, playerEdgeConstraint);
	    rmAddObjectDefConstraint(silver3ID, westIslandConstraint);
		
		if (cNumberNonGaiaPlayers<=2)
		rmPlaceObjectDefAtLoc(silver3ID, 0, 0.5, 0.5, 1.0*cNumberNonGaiaPlayers);
		else
		rmPlaceObjectDefAtLoc(silver3ID, 0, 0.5, 0.5, 0.5*cNumberNonGaiaPlayers);	

/*----------------------------------------------------------------------------------------------------------------*/

        // THE EASTERN SILVER MINES:
		int silver4ID = rmCreateObjectDef("silver east");
	    
		if ( whichVariation == 1 )
	{	
		rmAddObjectDefItem(silver4ID, "mine", 1, 0);
	}
        else
    {
        rmAddObjectDefItem(silver4ID, "minegold", 1, 0);
    }	
		
        rmSetObjectDefMinDistance(silver4ID, 0.0);
        rmSetObjectDefMaxDistance(silver4ID, rmXFractionToMeters(0.5));
	    rmAddObjectDefConstraint(silver4ID, avoidVeryFarCoin);
        rmAddObjectDefConstraint(silver4ID, avoidAll);
		//rmAddObjectDefConstraint(silver4ID, avoidWater12);
        rmAddObjectDefConstraint(silver4ID, avoidSockets);
	    rmAddObjectDefConstraint(silver4ID, avoidTradeRoute);
	    rmAddObjectDefConstraint(silver4ID, avoidNatives);
        rmAddObjectDefConstraint(silver4ID, avoidMediumImpassableLand);
	    //rmAddObjectDefConstraint(silver4ID, playerCloseConstraint);
	    rmAddObjectDefConstraint(silver4ID, playerEdgeConstraint);
	    rmAddObjectDefConstraint(silver4ID, eastIslandConstraint);
		
		if (cNumberNonGaiaPlayers<=2)
		rmPlaceObjectDefAtLoc(silver4ID, 0, 0.5, 0.5, 1.0*cNumberNonGaiaPlayers);
		else
		rmPlaceObjectDefAtLoc(silver4ID, 0, 0.5, 0.5, 0.5*cNumberNonGaiaPlayers);			

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.85);
/*================================================================================================================*/
// ************************************* DEFINE AND PLACE THE FOREST AREAS: ************************************* //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

        
	    // THE SOUTHERN FORESTS:
		int forestTreeID = 0;

	    if (cNumberNonGaiaPlayers <= 2)
		numTries=8*cNumberNonGaiaPlayers;
	    else
		numTries=4*cNumberNonGaiaPlayers;
	    
		failCount=0;
	    for (i=0; <numTries)
{   
		int forestID=rmCreateArea("forestID"+i, southIslandID);
		rmSetAreaWarnFailure(forestID, false);
		rmSetAreaSize(forestID, rmAreaTilesToFraction(160), rmAreaTilesToFraction(200));
		rmSetAreaForestType(forestID, "saguenay forest");
		rmSetAreaForestDensity(forestID, 0.9);
		rmSetAreaForestClumpiness(forestID, 0.7);		
		rmSetAreaForestUnderbrush(forestID, 0.6);
		rmSetAreaMinBlobs(forestID, 1);
		rmSetAreaMaxBlobs(forestID, 4);						
		rmSetAreaMinBlobDistance(forestID, 5.0);
		rmSetAreaMaxBlobDistance(forestID, 20.0);
		rmSetAreaCoherence(forestID, 0.4);
		rmSetAreaSmoothDistance(forestID, 10);
		rmAddAreaToClass(forestID, rmClassID("classForest"));
		rmAddAreaConstraint(forestID, forestConstraint);  
		rmAddAreaConstraint(forestID, avoidTradeRouteForest);
		rmAddAreaConstraint(forestID, avoidCinematicBlock);
		rmAddAreaConstraint(forestID, shortAvoidImportantItem);
		rmAddAreaConstraint(forestID, playerEdgeConstraint);
		rmAddAreaConstraint(forestID, playerConstraint);
		rmAddAreaConstraint(forestID, avoidCliff);
		rmAddAreaConstraint(forestID, avoidAll);
		rmAddAreaConstraint(forestID, avoidWater8);
		if(rmBuildArea(forestID)==false)
	{
		// Stop trying once we fail 5 times in a row.
		failCount++;
		if(failCount==10)
		break;
	}
	    else
		failCount=0; 
	}
	
/*---------------------------------------------------------------------------------------------------------------*/

	    // THE NORTHERN FORESTS:
		int forestTreeNorthID = 0;
		
		if (cNumberNonGaiaPlayers <= 2)
		numTries=8*cNumberNonGaiaPlayers;
	    else
		numTries=4*cNumberNonGaiaPlayers;
	      
	    failCount=0;
	    for (i=0; <numTries)
	{   
		int forestnorthID=rmCreateArea("forestNorthID"+i, northIslandID);
		rmSetAreaWarnFailure(forestnorthID, false);
		rmSetAreaSize(forestnorthID, rmAreaTilesToFraction(160), rmAreaTilesToFraction(200));
		rmSetAreaForestType(forestnorthID, "saguenay forest");
		rmSetAreaForestDensity(forestnorthID, 0.5);
		rmSetAreaForestClumpiness(forestnorthID, 0.4);		
		rmSetAreaForestUnderbrush(forestnorthID, 0.7);
		rmSetAreaMinBlobs(forestnorthID, 1);
		rmSetAreaMaxBlobs(forestnorthID, 4);						
		rmSetAreaMinBlobDistance(forestnorthID, 5.0);
		rmSetAreaMaxBlobDistance(forestnorthID, 20.0);
		rmSetAreaCoherence(forestnorthID, 0.4);
		rmSetAreaSmoothDistance(forestnorthID, 10);
		rmAddAreaToClass(forestnorthID, rmClassID("classForest"));
		rmAddAreaConstraint(forestnorthID, forestConstraint);  
		rmAddAreaConstraint(forestnorthID, avoidTradeRouteForest);
		rmAddAreaConstraint(forestnorthID, avoidCinematicBlock);
		rmAddAreaConstraint(forestnorthID, shortAvoidImportantItem);
		rmAddAreaConstraint(forestnorthID, playerConstraint);
		rmAddAreaConstraint(forestnorthID, playerEdgeConstraint);
		rmAddAreaConstraint(forestnorthID, avoidCliff);
		rmAddAreaConstraint(forestnorthID, avoidAll);
		rmAddAreaConstraint(forestnorthID, avoidWater8);
		if(rmBuildArea(forestnorthID)==false)
	{
		// Stop trying once we fail 5 times in a row.
		failCount++;
		if(failCount==10)
		break;
	}
	    else
		failCount=0; 
}

/*----------------------------------------------------------------------------------------------------------------*/

        // THE WESTERN FORESTS:
		int forestTreeWestID = 0;
		
		if (cNumberNonGaiaPlayers <= 2)
		numTries=3*cNumberNonGaiaPlayers;
	    else
		numTries=1.5*cNumberNonGaiaPlayers;
	      
	    failCount=0;
	    for (i=0; <numTries)
	{   
		int forestwestID=rmCreateArea("forestwestID"+i, westIslandID);
		rmSetAreaWarnFailure(forestwestID, false);
		rmSetAreaSize(forestwestID, rmAreaTilesToFraction(160), rmAreaTilesToFraction(200));
		rmSetAreaForestType(forestwestID, "saguenay forest");
		rmSetAreaForestDensity(forestwestID, 0.5);
		rmSetAreaForestClumpiness(forestwestID, 0.4);		
		rmSetAreaForestUnderbrush(forestwestID, 0.7);
		rmSetAreaMinBlobs(forestwestID, 1);
		rmSetAreaMaxBlobs(forestwestID, 4);						
		rmSetAreaMinBlobDistance(forestwestID, 5.0);
		rmSetAreaMaxBlobDistance(forestwestID, 20.0);
		rmSetAreaCoherence(forestwestID, 0.4);
		rmSetAreaSmoothDistance(forestwestID, 10);
		rmAddAreaToClass(forestwestID, rmClassID("classForest"));
		rmAddAreaConstraint(forestwestID, forestConstraint);  
		rmAddAreaConstraint(forestwestID, avoidCloseTradeRoute);
		rmAddAreaConstraint(forestwestID, avoidCinematicBlock);
		rmAddAreaConstraint(forestwestID, shortAvoidImportantItem);
		rmAddAreaConstraint(forestwestID, avoidCloseNatives);
		rmAddAreaConstraint(forestwestID, playerEdgeConstraint);
		rmAddAreaConstraint(forestwestID, avoidCloseSockets);
		rmAddAreaConstraint(forestwestID, avoidAll);
		rmAddAreaConstraint(forestwestID, avoidCloseNugget);
		rmAddAreaConstraint(forestwestID, avoidCloseCoin);
		if(rmBuildArea(forestwestID)==false)
	{
		// Stop trying once we fail 5 times in a row.
		failCount++;
		if(failCount==10)
		break;
	}
	    else
		failCount=0; 
}

/*----------------------------------------------------------------------------------------------------------------*/

        // THE EASTERN FORESTS:
		int forestTreeEastID = 0;
		
		if (cNumberNonGaiaPlayers <= 2)
		numTries=3*cNumberNonGaiaPlayers;
	    else
		numTries=1.5*cNumberNonGaiaPlayers;
	      
	    failCount=0;
	    for (i=0; <numTries)
	{   
		int foresteastID=rmCreateArea("foresteastID"+i, eastIslandID);
		rmSetAreaWarnFailure(foresteastID, false);
		rmSetAreaSize(foresteastID, rmAreaTilesToFraction(160), rmAreaTilesToFraction(200));
		rmSetAreaForestType(foresteastID, "saguenay forest");
		rmSetAreaForestDensity(foresteastID, 0.5);
		rmSetAreaForestClumpiness(foresteastID, 0.4);		
		rmSetAreaForestUnderbrush(foresteastID, 0.7);
		rmSetAreaMinBlobs(foresteastID, 1);
		rmSetAreaMaxBlobs(foresteastID, 4);						
		rmSetAreaMinBlobDistance(foresteastID, 5.0);
		rmSetAreaMaxBlobDistance(foresteastID, 20.0);
		rmSetAreaCoherence(foresteastID, 0.4);
		rmSetAreaSmoothDistance(foresteastID, 10);
		rmAddAreaToClass(foresteastID, rmClassID("classForest"));
		rmAddAreaConstraint(foresteastID, forestConstraint);  
		rmAddAreaConstraint(foresteastID, avoidCloseTradeRoute);
		rmAddAreaConstraint(foresteastID, avoidCinematicBlock);
		rmAddAreaConstraint(foresteastID, shortAvoidImportantItem);
		rmAddAreaConstraint(foresteastID, avoidCloseNatives);
		rmAddAreaConstraint(foresteastID, playerEdgeConstraint);
		rmAddAreaConstraint(foresteastID, avoidCloseSockets);
		rmAddAreaConstraint(foresteastID, avoidAll);
		rmAddAreaConstraint(foresteastID, avoidCloseNugget);
		rmAddAreaConstraint(foresteastID, avoidCloseCoin);
		if(rmBuildArea(foresteastID)==false)
	{
		// Stop trying once we fail 5 times in a row.
		failCount++;
		if(failCount==10)
		break;
	}
	    else
		failCount=0; 
}

/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.90);
/*================================================================================================================*/
// ************************************* DEFINE AND PLACE THE PUYAS TREES: ************************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.91);
/*================================================================================================================*/
// ******************************* RESOURCES THAT CAN BE PLACED AFTER FORESTS: ********************************** //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/
/*================================================================================================================*/
// ************************************* DEFINE AND PLACE THE DEER HERDS: *************************************** //
/*================================================================================================================*/

        // THE NORTHERN DEER HERDS:
		int deer1ID=rmCreateObjectDef("The Deer herds 1");
	    
		int bonusChance=rmRandFloat(0, 1);
	    if(bonusChance<0.5)   
		rmAddObjectDefItem(deer1ID, "deer", rmRandInt(4,6), 10.0);
	    else
		rmAddObjectDefItem(deer1ID, "deer", rmRandInt(8,10), 10.0);
	    
		rmSetObjectDefMinDistance(deer1ID, 0.0);
	    rmSetObjectDefMaxDistance(deer1ID, rmXFractionToMeters(0.5));
	    
		rmAddObjectDefConstraint(deer1ID, avoidAll);
		rmAddObjectDefConstraint(deer1ID, playerEdgeConstraint);
		rmAddObjectDefConstraint(deer1ID, avoidImportantItem);
		rmAddObjectDefConstraint(deer1ID, avoidNugget);
		rmAddObjectDefConstraint(deer1ID, avoidMediumCoin);
		rmAddObjectDefConstraint(deer1ID, northIslandConstraint);
		rmAddObjectDefConstraint(deer1ID, avoidFruits);
		rmAddObjectDefConstraint(deer1ID, playerConstraint);
	    rmAddObjectDefConstraint(deer1ID, avoidVeryFarDeer);
	    rmAddObjectDefConstraint(deer1ID, avoidImpassableLand);
		rmAddObjectDefConstraint(deer1ID, avoidWater8);
		rmAddObjectDefConstraint(deer1ID, avoidTradeRoute);
		rmAddObjectDefConstraint(deer1ID, avoidSockets);
		rmAddObjectDefConstraint(deer1ID, forestCloseConstraint);
	    
	    rmSetObjectDefCreateHerd(deer1ID, true);
		if (cNumberNonGaiaPlayers<=2)
		rmPlaceObjectDefAtLoc(deer1ID, 0, 0.5, 0.5, 2*cNumberNonGaiaPlayers);
		else
		rmPlaceObjectDefAtLoc(deer1ID, 0, 0.5, 0.5, 1*cNumberNonGaiaPlayers);	
		
	    
		
/*================================================================================================================*/

        // THE SOUTHERN DEER HERDS:
		int deer2ID=rmCreateObjectDef("The Deer herds 2");
	    
		bonusChance=rmRandFloat(0, 1);
	    if(bonusChance<0.5)   
		rmAddObjectDefItem(deer2ID, "deer", rmRandInt(4,6), 10.0);
	    else
		rmAddObjectDefItem(deer2ID, "deer", rmRandInt(8,10), 10.0);
	    
		rmSetObjectDefMinDistance(deer2ID, 0.0);
	    rmSetObjectDefMaxDistance(deer2ID, rmXFractionToMeters(0.5));
	    
		rmAddObjectDefConstraint(deer2ID, avoidAll);
		rmAddObjectDefConstraint(deer2ID, playerEdgeConstraint);
		rmAddObjectDefConstraint(deer2ID, avoidImportantItem);
		rmAddObjectDefConstraint(deer2ID, avoidMediumCoin);
		rmAddObjectDefConstraint(deer2ID, avoidNugget);
		rmAddObjectDefConstraint(deer2ID, southIslandConstraint);
		rmAddObjectDefConstraint(deer2ID, avoidFruits);
		rmAddObjectDefConstraint(deer2ID, playerConstraint);
	    rmAddObjectDefConstraint(deer2ID, avoidVeryFarDeer);
	    rmAddObjectDefConstraint(deer2ID, avoidImpassableLand);
		rmAddObjectDefConstraint(deer2ID, avoidWater8);
		rmAddObjectDefConstraint(deer2ID, avoidTradeRoute);
		rmAddObjectDefConstraint(deer2ID, avoidSockets);
		rmAddObjectDefConstraint(deer2ID, forestCloseConstraint);
	    
	    rmSetObjectDefCreateHerd(deer2ID, true);
		if (cNumberNonGaiaPlayers<=2)
		rmPlaceObjectDefAtLoc(deer2ID, 0, 0.5, 0.5, 2*cNumberNonGaiaPlayers);
		else
		rmPlaceObjectDefAtLoc(deer2ID, 0, 0.5, 0.5, 1*cNumberNonGaiaPlayers);

/*================================================================================================================*/
// ************************************** DEFINE AND PLACE THE BERRYBUSH: *************************************** //		
/*================================================================================================================*/

        // THE NORTHERN BERRYBUSH:
		int BerriesID=rmCreateObjectDef("The Berries 1");
        rmAddObjectDefItem(BerriesID, "berrybush", rmRandInt(3,7), 8.0);
        rmSetObjectDefMinDistance(BerriesID, 0.0);
        rmSetObjectDefMaxDistance(BerriesID, rmXFractionToMeters(0.5));
		
		rmAddObjectDefConstraint(BerriesID, avoidFarFruits);
		rmAddObjectDefConstraint(BerriesID, northIslandConstraint);
        rmAddObjectDefConstraint(BerriesID, avoidAll);
		rmAddObjectDefConstraint(BerriesID, avoidMediumDeer);
		rmAddObjectDefConstraint(BerriesID, forestConstraint);
		rmAddObjectDefConstraint(BerriesID, playerCloseConstraint);
		rmAddObjectDefConstraint(BerriesID, avoidMediumCoin);
		rmAddObjectDefConstraint(BerriesID, avoidNugget);
		rmAddObjectDefConstraint(BerriesID, avoidSockets);
		rmAddObjectDefConstraint(BerriesID, avoidTradeRoute);
		rmAddObjectDefConstraint(BerriesID, avoidImpassableLand);
		rmAddObjectDefConstraint(BerriesID, playerEdgeConstraint);
		rmAddObjectDefConstraint(BerriesID, avoidImportantItem);
		rmAddObjectDefConstraint(BerriesID, avoidWater15);
		        
		rmSetObjectDefCreateHerd(BerriesID, true);
		if (cNumberNonGaiaPlayers<=2)
		rmPlaceObjectDefAtLoc(BerriesID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*2.0);
		else
		rmPlaceObjectDefAtLoc(BerriesID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*1.0);
		
/*----------------------------------------------------------------------------------------------------------------*/

        // THE SOUTHERN BERRYBUSH:
		int Berries2ID=rmCreateObjectDef("The Berries 2");
        rmAddObjectDefItem(Berries2ID, "berrybush", rmRandInt(3,7), 8.0);
        rmSetObjectDefMinDistance(Berries2ID, 0.0);
        rmSetObjectDefMaxDistance(Berries2ID, rmXFractionToMeters(0.5));
		
		rmAddObjectDefConstraint(Berries2ID, avoidFarFruits);
		rmAddObjectDefConstraint(Berries2ID, southIslandConstraint);
        rmAddObjectDefConstraint(Berries2ID, avoidAll);
		rmAddObjectDefConstraint(Berries2ID, avoidMediumDeer);
		rmAddObjectDefConstraint(Berries2ID, forestConstraint);
		rmAddObjectDefConstraint(Berries2ID, playerCloseConstraint);
		rmAddObjectDefConstraint(Berries2ID, avoidMediumCoin);
		rmAddObjectDefConstraint(Berries2ID, avoidNugget);
		rmAddObjectDefConstraint(Berries2ID, avoidSockets);
		rmAddObjectDefConstraint(Berries2ID, avoidTradeRoute);
		rmAddObjectDefConstraint(Berries2ID, avoidImpassableLand);
		rmAddObjectDefConstraint(Berries2ID, playerEdgeConstraint);
		rmAddObjectDefConstraint(Berries2ID, avoidImportantItem);
		rmAddObjectDefConstraint(Berries2ID, avoidWater15);
		        
		rmSetObjectDefCreateHerd(Berries2ID, true);
		if (cNumberNonGaiaPlayers<=2)
		rmPlaceObjectDefAtLoc(Berries2ID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*2.0);
		else
		rmPlaceObjectDefAtLoc(Berries2ID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*1.0);
		
/*----------------------------------------------------------------------------------------------------------------*/

        // THE WESTERN BERRYBUSH:
		int Berries3ID=rmCreateObjectDef("The Berries 3");
        rmAddObjectDefItem(Berries3ID, "berrybush", rmRandInt(3,7), 8.0);
        rmSetObjectDefMinDistance(Berries3ID, 0.0);
        rmSetObjectDefMaxDistance(Berries3ID, rmXFractionToMeters(0.5));
		
		rmAddObjectDefConstraint(Berries3ID, avoidFarFruits);
		rmAddObjectDefConstraint(Berries3ID, westIslandConstraint);
        rmAddObjectDefConstraint(Berries3ID, avoidAll);
		rmAddObjectDefConstraint(Berries3ID, avoidCloseNatives);
		rmAddObjectDefConstraint(Berries3ID, forestCloseConstraint);
		rmAddObjectDefConstraint(Berries3ID, avoidMediumCoin);
		rmAddObjectDefConstraint(Berries3ID, avoidNugget);
		rmAddObjectDefConstraint(Berries3ID, avoidSockets);
		rmAddObjectDefConstraint(Berries3ID, avoidTradeRoute);
		rmAddObjectDefConstraint(Berries3ID, avoidImpassableLand);
		rmAddObjectDefConstraint(Berries3ID, playerEdgeConstraint);
		rmAddObjectDefConstraint(Berries3ID, avoidImportantItem);
			        
		rmSetObjectDefCreateHerd(Berries3ID, true);
		if (cNumberNonGaiaPlayers<=2)
		rmPlaceObjectDefAtLoc(Berries3ID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*1.0);
		else
		rmPlaceObjectDefAtLoc(Berries3ID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*0.5);

/*----------------------------------------------------------------------------------------------------------------*/

        // THE EASTERN BERRYBUSH:
		int Berries4ID=rmCreateObjectDef("The Berries 4");
        rmAddObjectDefItem(Berries4ID, "berrybush", rmRandInt(3,7), 8.0);
        rmSetObjectDefMinDistance(Berries4ID, 0.0);
        rmSetObjectDefMaxDistance(Berries4ID, rmXFractionToMeters(0.5));
		
		rmAddObjectDefConstraint(Berries4ID, avoidFarFruits);
		rmAddObjectDefConstraint(Berries4ID, eastIslandConstraint);
        rmAddObjectDefConstraint(Berries4ID, avoidAll);
		rmAddObjectDefConstraint(Berries4ID, avoidCloseNatives);
		rmAddObjectDefConstraint(Berries4ID, forestCloseConstraint);
		rmAddObjectDefConstraint(Berries4ID, avoidMediumCoin);
		rmAddObjectDefConstraint(Berries4ID, avoidNugget);
		rmAddObjectDefConstraint(Berries4ID, avoidSockets);
		rmAddObjectDefConstraint(Berries4ID, avoidTradeRoute);
		rmAddObjectDefConstraint(Berries4ID, avoidImpassableLand);
		rmAddObjectDefConstraint(Berries4ID, playerEdgeConstraint);
		rmAddObjectDefConstraint(Berries4ID, avoidImportantItem);
			        
		rmSetObjectDefCreateHerd(Berries4ID, true);
		if (cNumberNonGaiaPlayers<=2)
		rmPlaceObjectDefAtLoc(Berries4ID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*1.0);
		else
		rmPlaceObjectDefAtLoc(Berries4ID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*0.5);		
		

/*================================================================================================================*/
// ********************************** DEFINE AND PLACE THE SHEEP HERDS: **************************************** //
/*================================================================================================================*/

        // THE NORTHERN SHEEP HERDS:
		int sheep1ID=rmCreateObjectDef("The Sheep herds 1");
	    
		bonusChance=rmRandFloat(0, 1);
	    if(bonusChance<0.5)   
		rmAddObjectDefItem(sheep1ID, "sheep", rmRandInt(2,3), 4.0);
	    else
		rmAddObjectDefItem(sheep1ID, "sheep", rmRandInt(4,6), 6.0);
	    
		rmSetObjectDefMinDistance(sheep1ID, 0.0);
	    rmSetObjectDefMaxDistance(sheep1ID, rmXFractionToMeters(0.5));
	    
		rmAddObjectDefConstraint(sheep1ID, avoidAll);
		rmAddObjectDefConstraint(sheep1ID, avoidDeer);
	    rmAddObjectDefConstraint(sheep1ID, playerEdgeConstraint);
		rmAddObjectDefConstraint(sheep1ID, playerCloseConstraint);
		rmAddObjectDefConstraint(sheep1ID, northIslandConstraint);
		rmAddObjectDefConstraint(sheep1ID, forestConstraint);
		rmAddObjectDefConstraint(sheep1ID, avoidCloseTradeRoute);
		rmAddObjectDefConstraint(sheep1ID, avoidCloseSockets);
		rmAddObjectDefConstraint(sheep1ID, avoidNugget);
		rmAddObjectDefConstraint(sheep1ID, avoidCoin);
		rmAddObjectDefConstraint(sheep1ID, avoidFruits);
		rmAddObjectDefConstraint(sheep1ID, avoidVeryFarSheep);
	    rmAddObjectDefConstraint(sheep1ID, avoidImpassableLand);
		rmAddObjectDefConstraint(sheep1ID, avoidWater15);
	    
	    rmSetObjectDefCreateHerd(sheep1ID, true);
		if (cNumberNonGaiaPlayers<=2)
		rmPlaceObjectDefAtLoc(sheep1ID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*2.0);
		else
		rmPlaceObjectDefAtLoc(sheep1ID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*1.0);
		
/*----------------------------------------------------------------------------------------------------------------*/

        // THE SOUTHERN SHEEP HERDS:
		int sheep2ID=rmCreateObjectDef("The Sheep herds 2");
	    
		bonusChance=rmRandFloat(0, 1);
	    if(bonusChance<0.5)   
		rmAddObjectDefItem(sheep2ID, "sheep", rmRandInt(2,3), 4.0);
	    else
		rmAddObjectDefItem(sheep2ID, "sheep", rmRandInt(4,6), 6.0);
	    
		rmSetObjectDefMinDistance(sheep2ID, 0.0);
	    rmSetObjectDefMaxDistance(sheep2ID, rmXFractionToMeters(0.5));
	    
		rmAddObjectDefConstraint(sheep2ID, avoidAll);
		rmAddObjectDefConstraint(sheep2ID, avoidDeer);
	    rmAddObjectDefConstraint(sheep2ID, playerEdgeConstraint);
		rmAddObjectDefConstraint(sheep2ID, playerCloseConstraint);
		rmAddObjectDefConstraint(sheep2ID, southIslandConstraint);
		rmAddObjectDefConstraint(sheep2ID, forestConstraint);
		rmAddObjectDefConstraint(sheep2ID, avoidCloseTradeRoute);
		rmAddObjectDefConstraint(sheep2ID, avoidCloseSockets);
		rmAddObjectDefConstraint(sheep2ID, avoidNugget);
		rmAddObjectDefConstraint(sheep2ID, avoidCoin);
		rmAddObjectDefConstraint(sheep2ID, avoidFruits);
		rmAddObjectDefConstraint(sheep2ID, avoidVeryFarSheep);
	    rmAddObjectDefConstraint(sheep2ID, avoidImpassableLand);
		rmAddObjectDefConstraint(sheep2ID, avoidWater15);
	    
	    rmSetObjectDefCreateHerd(sheep2ID, true);
		if (cNumberNonGaiaPlayers<=2)
		rmPlaceObjectDefAtLoc(sheep2ID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*2.0);
		else
		rmPlaceObjectDefAtLoc(sheep2ID, 0, 0.5, 0.5, cNumberNonGaiaPlayers*1.0);		
				
/*================================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",0.95);
/*================================================================================================================*/   
// ************************************ DEFINE AND PLACE THE WOOD RESOURCES: ************************************ //
/*================================================================================================================*/
// NONE FOR NOW:
/*----------------------------------------------------------------------------------------------------------------*/

        // RANDOM TREES FOR THE 4 ISLANDS:
		int randomTreeID=rmCreateObjectDef("The Random Trees");
		rmAddObjectDefItem(randomTreeID, "TreeSaguenay", 1, 0.0);
		rmAddObjectDefToClass(randomTreeID, rmClassID("classTrees"));
		rmSetObjectDefMinDistance(randomTreeID, 0.0);
        rmSetObjectDefMaxDistance(randomTreeID, rmXFractionToMeters(0.5));
		
		rmAddObjectDefConstraint(randomTreeID, playerEdgeConstraint); 
	    rmAddObjectDefConstraint(randomTreeID, avoidCloseTradeRoute);
		rmAddObjectDefConstraint(randomTreeID, avoidCloseSockets);
		rmAddObjectDefConstraint(randomTreeID, avoidAll);
		rmAddObjectDefConstraint(randomTreeID, avoidCloseDeer);
		rmAddObjectDefConstraint(randomTreeID, avoidCloseSheep);
		rmAddObjectDefConstraint(randomTreeID, avoidWater12);
		rmAddObjectDefConstraint(randomTreeID, avoidImpassableLand);
		rmAddObjectDefConstraint(randomTreeID, playerCloseConstraint);
		rmAddObjectDefConstraint(randomTreeID, avoidCloseTrees);
		rmAddObjectDefConstraint(randomTreeID, avoidCloseCoin);
		rmAddObjectDefConstraint(randomTreeID, avoidCloseNugget);
			    	
		if (cNumberNonGaiaPlayers<=2)
		rmPlaceObjectDefAtLoc(randomTreeID, 0, 0.5, 0.5, 60*cNumberNonGaiaPlayers);
		else
		rmPlaceObjectDefAtLoc(randomTreeID, 0, 0.5, 0.5, 15*cNumberNonGaiaPlayers);
		
/*================================================================================================================*/
// **************************************** DEFINE AND PLACE THE FISHES: **************************************** //		
/*================================================================================================================*/
        
		int fishID=rmCreateObjectDef("fish");
        rmAddObjectDefItem(fishID, "FishSalmon", 3, 9.0);
        rmSetObjectDefMinDistance(fishID, 0.0);
        rmSetObjectDefMaxDistance(fishID, rmXFractionToMeters(0.5));
        rmAddObjectDefConstraint(fishID, fishVsFishID);
        rmAddObjectDefConstraint(fishID, fishLand);
        rmPlaceObjectDefAtLoc(fishID, 0, 0.5, 0.5, 10*cNumberNonGaiaPlayers);
		
/*===============================================================================================================*/
   // TEXT:
   // THESE STATUS TEXT LINES ARE USED TO MANUALLY ANIMATE THE MAP GENERATION PROGRESS BAR:
   rmSetStatusText("",1.00);
/*===============================================================================================================*/
}
/*===============================================================================================================*/
// ************************************** THIS IS THE END OF THE MAP: ****************************************** //
/*===============================================================================================================*/		














